<template>
    <node-view-wrapper class="wrap">
        <select aria-label="placeholder dropdown" ref="input" tabindex="-1" class="the-editor-context-placeholder" v-model="value" >
            <template v-for="option in options">
                <optgroup v-if="option.group" :label="option.group">
                    <option v-for="item in option.options" :value="item.value">{{item.label}}</option>
                </optgroup>
                <option v-else :value="option.value">{{option.label}}</option>
            </template>
        </select>
    </node-view-wrapper>
</template>


<script lang="ts" setup>
import { NodeViewWrapper, nodeViewProps } from '@tiptap/vue-3';
import { TextSelection } from '@tiptap/pm/state';
import {computed, watch, ref, onMounted} from 'vue'



const props = defineProps(nodeViewProps)
const input = ref<HTMLInputElement>()

// Watch to see if this is selected -- if so, focus the input
watch(()=>props.selected, (v)=>{
   if(v){
       input.value?.focus()
   }
})
function escape(before:boolean = false){
    const positionAfter = before ? props.getPos() : props.getPos() + 1
    const tr = props.editor.state.tr.setSelection(TextSelection.create(props.editor.state.doc, positionAfter, positionAfter))
    props.editor.view.dispatch(tr)
    props.editor.commands.focus()
}
onMounted(()=>{

    input.value?.addEventListener('keydown', (e)=>{
        if(e.key === 'Tab'){
            // handle TAB (illegal but we'll do it anyway)
            e.preventDefault()
            escape()
        }
        if (e.key === 'Escape'){
            escape()
        }
        if (e.key === 'ArrowRight'){
            e.preventDefault()
            escape()
        }
        if (e.key === 'ArrowLeft'){
            e.preventDefault()
            escape(true)
        }
    })

})

const value = computed({
    get: ()=>props.node?.attrs.value,
    set: (v: string)=>props.updateAttributes!({value: v})
})

const options = props.extension.options.options

</script>

<style scoped>
.wrap{
    display: inline-block;
    width: max-content;
}

select{
    all: revert;
}
select option{
    all: revert;
}
</style>
